﻿-- Author      : Nogarder
-- Create Date : 2013/4/20 16:50:07
local COMBATLOG_OBJECT_REACTION_MASK=COMBATLOG_OBJECT_REACTION_MASK
local pairs=pairs
local UnitGUID=UnitGUID
local next=next
local string_split=string.split
--
local bit_band=bit.band
--

local NPA_DataCollector_GetUnitDataByGUID=NPA.DataCollector.GetUnitDataByGUID

local NPA_CombatTextManager_AddText=NPA.CombatTextManager.AddText

local NPA_FrameToGUID_GetFrameDataByGUID=NPA.FrameToGUID.GetFrameDataByGUID
--
local NPA_SpellInfo_GetSpellInfo=NPA.SpellInfo.GetSpellInfo
--
local GetFrameByGUID=function(guid)
	--check player
	if(guid==UnitGUID("player"))then --this may change so using real-time one
		return UIParent --player's position is UIParent Center
	end
	--check guid to framedata
	local framedata=NPA_FrameToGUID_GetFrameDataByGUID(guid)
	if(framedata)then
		return framedata.ModuleMain
	end
	--not match 
	return nil
end
local GetType=function(guid,flag)
	--1=player 2=target 3=focus 4=mouseover ,64=hostile 32=neutral, 16=friendly
	if(guid==UnitGUID("player"))then
		return 1
	elseif(guid==UnitGUID("target"))then
		return 2
	elseif(guid==UnitGUID("focus"))then
		return 3
	elseif(guid==UnitGUID("mouseover"))then
		return 4
	else
		return bit_band(flag,COMBATLOG_OBJECT_REACTION_MASK) -- hostile=64, neutral=32, friendly=16
	end
end
--
--return icon,text,school
local GetIconAndText={
	--swing don't have icon
	["SWING_DAMAGE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[12]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[15] or 0)+(arg[16] or 0)+(arg[17] or 0)
			if(absorb>0)then
				text="-"..arg[12].."(-"..absorb..")"
			else
				text="-"..arg[12]
			end
		end
		return nil,text,0
	end,
	["SWING__EXTRA_ATTACKS"]=function(arg,texttype) --same as damage
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[12]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[15] or 0)+(arg[16] or 0)+(arg[17] or 0)
			if(absorb>0)then
				text="-"..arg[12].."(-"..absorb..")"
			else
				text="-"..arg[12]
			end
		end
		return nil,text,0
	end,
	--
	["SWING_MISSED"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[12]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[15] or 0)+(arg[16] or 0)+(arg[17] or 0)
			if(absorb>0)then
				text="-"..arg[12].."(-"..absorb..")"
			else
				text="-"..arg[12]
			end
		end
		return nil,text,0
	end,
	--
	--range type-- range also don't have icon
	["RANGE_DAMAGE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[18] or 0)+(arg[19] or 0)+(arg[20] or 0)
			if(absorb>0)then
				text="-"..arg[15].."(-"..absorb..")"
			else
				text="-"..arg[15]
			end
		end
		return nil,text,0
	end,
	--
	["RANGE_EXTRA_ATTACKS"]=function(arg,texttype) --same as damage
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[18] or 0)+(arg[19] or 0)+(arg[20] or 0)
			if(absorb>0)then
				text="-"..arg[15].."(-"..absorb..")"
			else
				text="-"..arg[15]
			end
		end
		return nil,text,0
	end,
	["RANGE_MISSED"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			text="-"..arg[15].."("..arg[17]..")"
		end
		return nil,text,0
	end,
	--spell damage type
	["SPELL_DAMAGE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[18] or 0)+(arg[19] or 0)+(arg[20] or 0)
			if(absorb>0)then
				text="-"..arg[15].."(-"..absorb..")"
			else
				text="-"..arg[15]
			end
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[17]
	end,
	--
	["SPELL_PERIODIC_DAMAGE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			local absorb=(arg[18] or 0)+(arg[19] or 0)+(arg[20] or 0)
			if(absorb>0)then
				text="-"..arg[15].."(-"..absorb..")"
			else
				text="-"..arg[15]
			end
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[17]
	end,
	--
	["SPELL_MISSED"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			text="-"..arg[15].."("..arg[17]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--["SPELL_DISPEL_FAILED"]=function(arg,texttype) --when to use these?
	--["SPELL_DAMAGE_SHIELD_DAMAGE"]=function(arg,texttype)
	--["SPELL_DAMAGE_SPLIT_DAMAGE"]=true,
	--["SPELL_DAMAGE_SHIELD_MISSED"]=true,
	--aura apply type
	["SPELL_AURA_APPLIED"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="+"
		elseif(texttype==2)then --2=detail
			text="+("..arg[15]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_AURA_APPLIED_DOSE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="+"..arg[16]
		elseif(texttype==2)then --2=detail
			text="+"..arg[16].."("..arg[15]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--aura remove type
	["SPELL_AURA_REMOVED"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"
		elseif(texttype==2)then --2=detail
			text="-("..arg[15]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--
	["SPELL_AURA_BROKEN"]=function(arg,texttype) --same as removed
		local text
		if(texttype==1)then --1=no detail
			text="X"
		elseif(texttype==2)then --2=detail
			text="X("..arg[15]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--
	["SPELL_AURA_BROKEN_SPELL"]=function(arg,texttype) --arg is slightly different
		local text
		if(texttype==1)then --1=no detail
			text="X"
		elseif(texttype==2)then --2=detail
			text="X("..arg[18]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--
	["SPELL_AURA_REMOVED_DOSE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[16]
		elseif(texttype==2)then --2=detail
			text="-"..arg[16].."("..arg[15]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_STOLEN"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="X"
		elseif(texttype==2)then --2=detail
			text="X("..arg[18]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[15]).Icon,text,arg[14]
	end,
	["SPELL_DISPEL"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="X"
		elseif(texttype==2)then --2=detail
			text="X("..arg[18]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[15]).Icon,text,arg[14]
	end,
	--energy type
	["SPELL_ENERGIZE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="+"..arg[15]
		elseif(texttype==2)then --2=detail
			text="+"..arg[15].."("..arg[16]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_DRAIN"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			text="-"..arg[15].."("..arg[16]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_LEECH"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[15]
		elseif(texttype==2)then --2=detail
			text="-"..arg[15].."("..arg[16]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--inturrpt type
	["SPELL_INTERRUPT"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="X"..arg[13]
		elseif(texttype==2)then --2=detail
			text="X"..arg[13].."("..arg[16]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[15]).Icon,text,arg[14]
	end,
	--summon type
	["SPELL_CREATE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="->"..arg[9]
		elseif(texttype==2)then --2=detail
			text="->"..arg[9].."("..arg[13]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_SUMMON"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="->"..arg[9]
		elseif(texttype==2)then --2=detail
			text="->"..arg[9].."("..arg[13]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_RESURRECT"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="=>"..arg[9]
		elseif(texttype==2)then --2=detail
			text="=>"..arg[9].."("..arg[13]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	--special type
	--["UNIT_DIED"]=function(arg,texttype) --died ,placeholder
	--	return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	--end,
	["UNIT_DESTROYED"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="X"..arg[9]
		elseif(texttype==2)then --2=detail
			text="X"..arg[9].."("..arg[13]..")"
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["ENVIRONMENTAL_DAMAGE"]=function(arg,texttype)
		local text
		if(texttype==1)then --1=no detail
			text="-"..arg[13]
		elseif(texttype==2)then --2=detail
			text="-"..arg[13].."("..arg[12]..")"
		end
		return nil,text,0
	end,
	--heal type
	["SPELL_HEAL"]=function(arg,texttype)
		local text
		local absorb=(arg[16] or 0) +(arg[17] or 0)
		if(absorb>0)then
			if(texttype==1)then --1=no detail
				text="+"..(arg[13]-absorb)
			elseif(texttype==2)then --2=detail
				text="+"..(arg[13]-absorb).."("..absorb")"
			end
		else
			text="+"..arg[13]
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
	["SPELL_PERIODIC_HEAL"]=function(arg,texttype) --same as heal
		local text
		local absorb=(arg[16] or 0) +(arg[17] or 0)
		if(absorb>0)then
			if(texttype==1)then --1=no detail
				text="+"..(arg[13]-absorb)
			elseif(texttype==2)then --2=detail
				text="+"..(arg[13]-absorb).."("..absorb..")"
			end
		else
			text="+"..arg[13]
		end
		return NPA_SpellInfo_GetSpellInfo(arg[12]).Icon,text,arg[14]
	end,
}
--
--
NPA.EventHandler.RegisterEvent(6,"CombatText_SettingUpdated","CombatText_Main",function()
	--if setting is empty, unregister event
	if(next(NPA_Setting.CombatText))then
		local AnimationList=NPA_Setting.CombatText.Animation
		--build filter
		local Filter={
			[0]={},	--0=any, 
			[1]={},	--1=player
			[2]={},	--2=target
			[3]={},	--3=focus
			[4]={},	--4=mouseover
			[16]={}, --friendly=16
			[32]={},	--neutral=32,
			[64]={},	--hostile=64
		}
		--
		for _,data in pairs(NPA_Setting.CombatText.Condition)do
			if(not Filter[data.From][data.To])then
				Filter[data.From][data.To]={}
			end
			Filter[data.From][data.To][data.CritType]=data --crittype,1=non-crit,2=crit,0=both
		end
		--
		--
		NPA.EventHandler.RegisterEvent(5,"Any","CombatText_Main",function(event,arg)
			local parentframe=GetFrameByGUID(arg[8])
			if(parentframe)then
				local from=GetType(arg[4],arg[6])
				local to=GetType(arg[8],arg[10])
				local setting=(Filter[from][to] or Filter[from][0] or Filter[0][to] or Filter[0][0])
				if(setting)then --setting exists
					local crittype
					if((event=="SWING_DAMAGE" and arg[18]) or	arg[21])then --crit info of melee swing is arg[18],else is arg[21]
						crittype=1 
					else
						crittype=0
					end
					setting=setting[crittype] or setting[0]
					if(setting and setting.EventList[event] and GetIconAndText[event] and setting.AnimationName)then --event filter
						local icon,text,school=GetIconAndText[event](arg,setting.TextType)
						NPA_CombatTextManager_AddText(parentframe,icon,text,school,setting,AnimationList[setting.AnimationName])
					end
				end
			end
		end)
	else
		NPA.EventHandler.RegisterEvent(5,"Any","CombatText_Main",nil)
	end
end)
--

--EventList={
--	--melee type
--	["SWING_DAMAGE"]=true,
--	["SWING_MISSED"]=true,
--	["SWING_EXTRA_ATTACKS"]=true,
--range type
--	["RANGE_DAMAGE"]=true,
--	["RANGE_MISSED"]=true,
--	["RANGE_EXTRA_ATTACKS"]=true,
--	--spell damage type
--	["SPELL_DAMAGE"]=true,
-- ["SPELL_PERIODIC_DAMAGE"]=true,
--	["SPELL_MISSED"]=true,
--	["SPELL_DISPEL_FAILED"]=true, --dispel fail
--	--damage shield type
--	["SPELL_DAMAGE_SHIELD_DAMAGE"]=true,
--	["SPELL_DAMAGE_SPLIT_DAMAGE"]=true,
--	["SPELL_DAMAGE_SHIELD_MISSED"]=true,
--	--aura apply type
--	["SPELL_AURA_APPLIED"]=true,
--	["SPELL_AURA_APPLIED_DOSE"]=true,
--	--aura remove type
--	["SPELL_AURA_REMOVED"]=true,
--	["SPELL_AURA_REMOVED_DOSE"]=true,
--	["SPELL_AURA_BROKEN"]=true, --removed by melee --usually cc spell
--	["SPELL_AURA_BROKEN_SPELL"]=true, --removed by spell
--	["SPELL_STOLEN"]=true, --stolen for mage
--	["SPELL_DISPEL"]=true,
--	--energy type
--	["SPELL_ENERGIZE"]=true, --get energy by spell
--	["SPELL_DRAIN"]=true, --cause target to lose energy by spell
--	["SPELL_LEECH"]=true, --cause target to lose energy ,and get energy for self, by spell
--	--inturrpt type
--	["SPELL_INTERRUPT"]=true, --get interrupt by spell
--	--summon type
--	["SPELL_CREATE"]=true, --create something 
--	["SPELL_SUMMON"]=true, --summon, like pet, tottem,etc
--	["SPELL_RESURRECT"]=true, --resurrect someone
--	--special type
--	["UNIT_DIED"]=true, --unit just died
--	["UNIT_DESTROYED"]=true, --happens to old tottem when new tottem is summoned 
--	["ENVIRONMENTAL_DAMAGE"]=true, --environmental damage,
-- --heal type
--["SPELL_HEAL"]=true,
--["SPELL_PERIODIC_HEAL"]=true,
--}
