﻿-- Author      : Nogarder
-- Create Date : 2012/3/20 4:16:40
local GetSpellInfo=GetSpellInfo
local floor=floor
local strfind=string.find
--main
local NPA_GetTime=NPA.GetTime
local SpellLib={}
--spell lib structure
--NPA.SpellLib[spellid]={
--name
--icon
--casttime
--school
--minrange
--maxrange
--cooldown type : 2=stack(new in 5.0) or 1=old school
--cooldown length
--stack count (for stack type only)
--max stack
NPA.SpellInfo={}
--functions
local SpellCache={}
NPA.SpellInfo.GetSpellInfo=function(spellid)
	--check lib
	local data=SpellLib[spellid]
	if(not data)then
		data=SpellCache[spellid]
		if(not data)then
			--name,icon,casttime,school,minrange,maxrange,cooldown,cooldownstack,length,maxstack
			--no match in lib, using system function
			--name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo()
			local name, _,icon, _,_,_,casttime,minrange,maxrange=GetSpellInfo(spellid)
			if(casttime==nil) then
				casttime=0
			else
				casttime=casttime/1000
			end
			--cache up spell data, this prevent frequent table generation, should increase speed
			SpellCache[spellid]={
				Name=name,
				Icon=icon,
				CastTime=casttime,
				MinRange=minrange,
				MaxRange=maxrange
			}
			data=SpellCache[spellid]
		end
	end
	return data
end
--
--return castinfo
NPA.SpellInfo.GetCastInfo=function(unit)
	-- spellname, rank, displayName, icon, startTime, endTime, isTradeSkill, castID, notinterrupt=UnitCastingInfo(unit)
	local _, _, name, icon, starttime, endtime, _, _, nointerrupt=UnitCastingInfo(unit)
	local channeling
	if((not name) or name=="Channeling")then
		-- spellname, rank, displayName, icon, startTime, endTime, isTradeSkill,  notinterrupt =UnitChannelInfo(unit)
		--revers endtime and starttime
		_,_,name,icon,starttime,endtime, _,nointerrupt = UnitChannelInfo(unit)
		if(not name)then
			return nil
		end
		channeling=true
	end
	if(not endtime)then
		--delay 1s
		endtime=NPA_GetTime()+1
	else
		--UnitCasting info returns strange timestamp, it can translate this way , don't know why
		endtime=floor(endtime/10)/100
		--in case the casting is already ended
		if(endtime<NPA_GetTime())then
			return nil
		end
	end
	--
	if(not starttime)then
		starttime=NPA_GetTime()
	else
		--blizzard time is exactly 1000xGetTime , don't know why
		starttime=floor(starttime/10)/100
	end
	--
	return name,icon,starttime,endtime,nointerrupt,channeling
end
--spellinfo auto cache, costy
--placeholder

--NPA.EventHandler.RegisterEvent(1,"Core_Setting_Updated","SpellInfo_AutoCache",function()
--if(options==true)then
--NPA.EventHandler.RegisterEvent(
--		NPA.EventHandler.RegisterEvent(2,"DataCollector_CollectUnit","NPA_Options_SpellAutoDetector",function(unit)			
--			local i=1
--			--seek every debuff on unit
--			repeat
--				--name, rank, icon , count , bufftype , duration , expirationtime , unitcaster , isstealable , shouldconsolidate , spellid = UnitBuff(unit,i)
--				local name,_,_ , _ , bufftype , duration , _ , _ , _ ,_ , spellid = UnitDebuff(unit,i)
--				--
--				if(spellid and spelldata[spellid])then
--					spelldata[spellid].Class=bufftype or "None"
--					spelldata[spellid].Length=spelldata[spellid].Length or duration
--				end
--				i=i+1
--			until(not name)
--			--and buff
--			local i=1
--			repeat
--				--name, rank, icon , count , bufftype , duration , expirationtime , unitcaster , isstealable , shouldconsolidate , spellid = UnitBuff(unit,i)
--				local name,_,_ , _ , bufftype , duration , _ , _ , _ ,_ , spellid = UnitBuff(unit,i)
--				--
--				if(spellid and spelldata[spellid])then
--					spelldata[spellid].Class=bufftype or "None"
--					spelldata[spellid].Length=spelldata[spellid].Length or duration
--				end
--				i=i+1
--			until(not name)
--		end)
--1,"","SpellInfo_AutoCache",function(event,framedata,loopback)
NPA.EventHandler.RegisterEvent(6,"SettingManager_SettingLoaded","Spell_Manager",function()
	SpellLib=NPA_Setting.SpellLib
end)