﻿-- Author      : Nogarder
-- Create Date : 2013/4/24 13:43:16
NPA_Options.RegisterPageFunc("CombatTextConditionEditor",function()

	local pairs=pairs
	local CopyTable=CopyTable
	local table_insert=table.insert
	local table_getn=table.getn
	--
	local Localization=NPA_Options.Localization.PagesCombatText
	local Tooltips=Localization.Tooltips
	--
	local main=NPA_Options.Template.CreateFrameWithBar(NPA_Options.MainFrame,Localization["Condition"],420,620,nil,nil,nil)
	main:Hide()
	local page=main.Frame
	--
	--elements
	local step=-20
	local Entry
	local CheckList={}
	--save
	local savebutton=NPA_Options.Template.CreateSpecialButton(page,130,15,"Save")
	savebutton:SetPoint("TOPLEFT",page,"TOPLEFT",5,-5)
	--reset
	local resetbutton=NPA_Options.Template.CreateSpecialButton(page,130,15,"Reset")
	resetbutton:SetPoint("TOPRIGHT",page,"TOPRIGHT",-5,-5)
	--cancel
	local cancelbutton=NPA_Options.Template.CreateSpecialButton(page,130,15,"Cancel")
	cancelbutton:SetPoint("LEFT",savebutton,"RIGHT",5,0)
	cancelbutton:SetPoint("RIGHT",resetbutton,"LEFT",-5,0)
	--
	local GetFromToList=function()
		return Localization.FromToList
	end
	--from selector
	local fromselector=NPA_Options.Template.CreateDropDownEditor(page,200,Localization["From"],Tooltips["From"],GetFromToList)
	fromselector:SetPoint("TOPLEFT",savebutton,"BOTTOMLEFT",0,step)
	--to selector
	local toselector=NPA_Options.Template.CreateDropDownEditor(page,200,Localization["To"],Tooltips["To"],GetFromToList)
	toselector:SetPoint("TOPLEFT",fromselector,"BOTTOMLEFT",0,step)
	--crit selector
	local GetCritList=function()
		return Localization.CritList
	end
	local critselector=NPA_Options.Template.CreateDropDownEditor(page,200,Localization["Critical"],Tooltips["Critical"],GetCritList)
	critselector:SetPoint("TOPLEFT",toselector,"BOTTOMLEFT",0,step)
	--font
	local fontselector=NPA_Options.Template.CreateFontEditorButton(page,main,160)
	fontselector:SetPoint("TOPLEFT",critselector,"BOTTOMLEFT",0,step)
	--text width slider
	local textwidthslider=NPA_Options.Template.CreateSliderEdit(page,150,50,20,0,100,1,0,Localization["TextWidth"],Tooltips["TextWidth"])
	textwidthslider:SetPoint("TOPLEFT",fontselector,"BOTTOMLEFT",0,step)
	--text height slider
	local textheightslider=NPA_Options.Template.CreateSliderEdit(page,150,50,20,1,100,1,1,Localization["TextHeight"],Tooltips["TextHeight"])
	textheightslider:SetPoint("TOPLEFT",textwidthslider,"BOTTOMLEFT",0,step)
	--text type selector
	local GetTextType=function()
		return Localization.TextType
	end
	local texttypeselector=NPA_Options.Template.CreateDropDownEditor(page,200,Localization["DetailedType"],Tooltips["DetailedType"],GetTextType)
	texttypeselector:SetPoint("TOPLEFT",textheightslider,"BOTTOMLEFT",0,step)
	--iconsize slider
	local iconsizeslider=NPA_Options.Template.CreateSliderEdit(page,150,50,20,1,100,1,1,Localization["IconSize"],Tooltips["IconSize"])
	iconsizeslider:SetPoint("TOPLEFT",texttypeselector,"BOTTOMLEFT",0,step)
	--bgtexture
	local bgtextureselector=NPA_Options.Template.CreateTextureSelectorButton(page,main,160)
	bgtextureselector:SetPoint("TOPLEFT",iconsizeslider,"BOTTOMLEFT",0,step)
	--bg width slider
	local bgwidthslider=NPA_Options.Template.CreateSliderEdit(page,150,50,20,-10,10,1,0,Localization["BGWidth"],Tooltips["BGWidth"])
	bgwidthslider:SetPoint("TOPLEFT",bgtextureselector,"BOTTOMLEFT",0,step)
	--bg height slider
	local bgheightslider=NPA_Options.Template.CreateSliderEdit(page,150,50,20,-10,10,1,1,Localization["BGHeight"],Tooltips["BGHeight"])
	bgheightslider:SetPoint("TOPLEFT",bgwidthslider,"BOTTOMLEFT",0,step)
	--bgcolor
	local bgcolorbutton=NPA_Options.Template.CreateColorButton(page,200,20,nil,main)
	bgcolorbutton:SetPoint("TOPLEFT",bgheightslider,"BOTTOMLEFT",0,step)
	--
	--right half of the page
	--checkbox list
	local checkboxlist=NPA_Options.Template.CreateCheckBoxList(page,180,440)
	checkboxlist.Scroll:SetPoint("TOPRIGHT",resetbutton,"BOTTOMRIGHT",-20,step)
	
	NPA_Options.Template.SetCheckBoxList(checkboxlist,20,function(name,value)
			CheckList[name]=value
		end,
		nil,
		nil	)
	--
	--preview
	local previewframe=CreateFrame("Frame",nil,page)
	previewframe:SetPoint("TOPLEFT",bgcolorbutton,"BOTTOMLEFT",0,-5)
	previewframe:SetPoint("BOTTOMRIGHT",page,"BOTTOMRIGHT",-5,5)
	--
	local previewbg=previewframe:CreateTexture(nil,"BACKGROUND")
	previewbg:SetPoint("TOPLEFT",previewframe,"TOPLEFT")
	previewbg:SetPoint("BOTTOMRIGHT",previewframe,"BOTTOMRIGHT")
	previewbg:SetTexture(0,0,0,0.25)
	--
	--NPA.CombatTextManager.AddText=function(parent,icon,text,school,setting,animation)
	local PreviewAnimation={
		[1]={
			SpeedType=0, --0=fixed ,1=vertical random, 2=horizonal random, 4=double random
			SpeedX=0,
			SpeedY=0,
			AccType=0,--0=fixed ,1=vertical random, 2=horizonal random, 4=double random
			AccX=0,
			AccY=0,
			StartAlpha=1,
			EndAlpha=1,
			StartSize=1,
			EndSize=1,
			ShakeRange=0,
			Lasts=1,
			FrameLevel=previewframe:GetFrameLevel()+3
		}
	}
	--
	local timer=0
	page:HookScript("OnUpdate",function(_,elapse)
		timer=timer+elapse
		if(timer>1)then
			timer=0
			--
			local entry={
				IconSize=iconsizeslider.Value,
				TextWidth=textwidthslider.Value,
				TextHeight=textheightslider.Value,
				TextFileName=fontselector.Value,
				BGWidth=bgwidthslider.Value,
				BGHeight=bgheightslider.Value,
				BGFileName=bgtextureselector.Value,
				BGColor=bgcolorbutton.Value
			}
			--
			local icon="Interface\\Icons\\Trade_Engineering"
			--
			local text
			if(texttypeselector.Value==1)then
				text=floor(random()*10000)
			elseif(texttypeselector.Value==2)then
				text=floor(random()*10000).."(Detailed text)"
			end
			--
			local school=math.pow(2,floor(random()*7))
			--set it
			NPA.CombatTextManager.AddText(previewframe,icon,text,school,entry,PreviewAnimation)
		end
	end)
	--
	local UpdateCheckList=function()
		NPA_Options.Template.UpdateCheckBoxList(checkboxlist,CheckList,Localization["EventLocalization"])
	end
	--
	local LoadData=function(default)
		--
		local entry
		if(default)then
			--get default directly from setting manager
			entry=NPA.SettingManager.GetDefault("CombatText")
		else
			entry=Entry
		end
		--from selector
		local value=entry.From
		NPA_Options.Template.SetDropDownEditor(fromselector,value)
		--to selector
		local value=entry.To
		NPA_Options.Template.SetDropDownEditor(toselector,value)
		--crittype
		local value=entry.CritType
		NPA_Options.Template.SetDropDownEditor(critselector,value)
		--iconsize slider
		local value=entry.IconSize
		NPA_Options.Template.SetSliderEdit(iconsizeslider,value)
		--text file
		local value=entry.TextFileName
		NPA_Options.Template.SetDropDownEditor(fontselector,value)
		--text width slider
		local value=entry.TextWidth
		NPA_Options.Template.SetSliderEdit(textwidthslider,value)
		--text height slider
		local value=entry.TextHeight
		NPA_Options.Template.SetSliderEdit(textheightslider,value)
		--text type selector
		local value=entry.TextType
		NPA_Options.Template.SetDropDownEditor(texttypeselector,value)
		--bg file
		local value=entry.BGFileName
		NPA_Options.Template.SetDropDownEditor(bgtextureselector,value)
		--bg width slider
		local value=entry.BGWidth
		NPA_Options.Template.SetSliderEdit(bgwidthslider,value)
		--bg height slider
		local value=entry.BGHeight
		NPA_Options.Template.SetSliderEdit(bgheightslider,value)
		--bgcolor
		local value=entry.BGColor
		NPA_Options.Template.SetColorButton(bgcolorbutton,value)
		--create checkboxlist
		CheckList=CopyTable(entry.EventList)
		--
		UpdateCheckList()
		--
	end
	--
	local SaveData=function()
		--from selector
		Entry.From=fromselector.Value
		--to selector
		Entry.To=toselector.Value
		--crittype
		Entry.CritType=critselector.Value
		--iconsize slider
		IconSize=iconsizeslider.Value
		--text file
		Entry.TextFileName=fontselector.Value
		--text width slider
		Entry.TextWidth=textwidthslider.Value
		--text height slider
		Entry.TextHeight=textheightslider.Value
		--text type selector
		Entry.TextType=texttypeselector.Value
		--bg file
		Entry.BGFileName=bgtextureselector.Value
		--bg width slider
		Entry.BGWidth=bgwidthslider.Value
		--bg height slider
		Entry.BGHeight=bgheightslider.Value
		--bgcolor
		Entry.BGColor=CopyTable(bgcolorbutton.Value)
		--eventlist
		Entry.EventList=CopyTable(CheckList)
		--fire event
		NPA.EventHandler.FireEvent(6,"CombatText_SettingUpdated")
	end
	--
	savebutton:HookScript("OnMouseUp",function()
		NPA_Options.Animation.ShowFrame(main)
		SaveData()
	end)
	cancelbutton:HookScript("OnMouseUp",function()
		SetPreview()
		NPA_Options.Animation.ShowFrame(main)
		LoadData()
	end)
	resetbutton:HookScript("OnMouseUp",function()
		NPA_Options.Animation.ShowFrame(main)
		LoadData(true)
	end)
	--
	main.OnSetFunc=function(entryname)
		Entry=NPA_Setting.CombatText.Condition[entryname]
		--
		LoadData()
	end
	--
	NPA_Options.RegisterPage("CombatTextConditionEditor",main)
end)